<?php           
defined('C5_EXECUTE') or die(_("Access Denied."));

class SkybluesofaSocialConnectBlockController extends BlockController {
	
	var $pobj;

	protected $btTable = 'btSkybluesofaSocialConnect';
	protected $btConnectionsTable = 'btSkybluesofaSocialConnections';
	protected $btInterfaceWidth = "580";
	protected $btInterfaceHeight = "400";
	protected $db = null;
			
	/** 
	 * Used for localization. If we want to localize the name/description we have to include this
	 */
	public function getBlockTypeDescription() {
		return t("Displays your social icons on your site");
	}
	
	public function getBlockTypeName() {
		return t("Social Connect");
	}		
	
	
	public function __construct($obj = null) {		
		parent::__construct($obj); 
		$this->db = Loader::db();
	}
	
	public function view() {
		if (empty($this->iconSize)) $this->iconSize = 32;
		if (empty($this->layout)) $this->layout = 'horizontal';
		if (empty($this->showNames)) $this->showNames = false;
		if (empty($this->animation)) $this->animation = false;
		if (empty($this->tooltip)) $this->tooltip = "Connect with me";
		$this->set('iconSize', $this->iconSize);
		$this->set('layout', $this->layout);
		$this->set('showNames', $this->showNames ? true : false);
		$this->set('animation', $this->animation ? true : false);
		$this->set('networks', $this->getNetworks());
		$this->set('connections', $this->getConnections($this->bID));
	}

	function add() {
		$this->set('networks', $this->getNetworks());
		$this->set('connections', $this->getConnections($this->bID));
	}
	
	function edit() {
		$this->set('networks', $this->getNetworks());
		$this->set('connections', $this->getConnections($this->bID));
	}
	
	/*
	 * save block config
	 */ 
	public function save($args) {
		$args['floating_offset'] = empty($args['floating_offset']) ? '0' : $args['floating_offset'];
		parent::save($args);
		$this->saveConnections($this->bID, $args);
	}
	
	function duplicate($newBID) {
		parent::duplicate($newBID);
		$this->duplicateConnections($newBID);
	}
		
	public function getConnections($bID) {
        $po = $this->db->GetArray("SELECT * FROM ".$this->btConnectionsTable." WHERE ordinal IS NOT NULL AND bID = ? ORDER BY ordinal", array($bID));
        $no = $this->db->GetArray("SELECT * FROM ".$this->btConnectionsTable." WHERE ordinal IS NULL AND bID = ? ORDER BY connID", array($bID));
        $res = array_merge($po, $no);
        return $res;
	}
	
	public function saveConnections($bID, $args) {
		if (!isset($args['connection']) || !is_array($args['connection'])) {
			return false;
		}
		$this->deleteConnections($bID);
		$ordinal = 1;
		foreach ($args['connection']['connection'] as $key=>$value) {
	
			if ($key && !empty($args['connection']['network'][$key]) && !empty($args['connection']['connection'][$key])) {
				//if (in_array($args['connection']['network'][$key], $this->getNetworks())) {
					$netconn['bID'] = $bID;
					$netconn['ordinal'] = $ordinal;
					$netconn['network'] = $args['connection']['network'][$key];
					$netconn['url'] = $args['connection']['connection'][$key];
					$this->addConnection($bID, $netconn);
					$ordinal++;
				//}
			}
		}
	}
	
	function duplicateConnections($newBID) {
		$b=$this->getBlockObject(); 
		$c=$b->getBlockCollectionObject();	 
		 
		$res = $this->db->query("select * from " . $this->btTable . " where bID = ?", array($this->bID));
		$existingBlock = $res->fetchRow();
		
		if(count($existingBlock)>0){ 
			$oldBID=$existingBlock['bID'];
			
			$res = $this->db->GetArray("SELECT * FROM ".$this->btConnectionsTable." WHERE bID=?", array($this->bID));
			$existingConnections = array('connection'=>array());
			$existingConnections['connection']['network'][]=null;
			$existingConnections['connection']['connection'][]=null;
			foreach ($res as $key=>$connection) {
				$existingConnections['connection']['network'][]=$connection['network'];
				$existingConnections['connection']['connection'][]=$connection['url'];
			}
			$this->saveConnections($newBID, $existingConnections);
		} else {
			return 0;
		}
	}
	
	public function addConnection($bID, $newNetConn) {
		if (!is_array($newNetConn)) {
			return false;
		}
		$netconn = array('bID'=>$bID, 'ordinal'=>null, 'network'=>null, 'url'=>null);
		foreach ($netconn as $key=>$value) {
			if (array_key_exists($key, $newNetConn)) {
				$netconn[$key] = $newNetConn[$key];
			}
		}
	
		$res = $this->db->Execute("INSERT INTO ".$this->btConnectionsTable." (bID, ordinal, network, url) VALUES (?, ?, ?, ?)", $netconn);
		return $res;
	}
	
	public function deleteConnections($bID) {
        $res = $this->db->Execute("DELETE FROM ".$this->btConnectionsTable." WHERE bID = ?", array($bID));
        return $res;
	}
	
	public function getNetworks() {
		if (!isset($this->networks) || !$this->networks) {
			$this->networks['about.me'] = "aboutdotme";
			$this->networks['AIM'] = "aim";
			$this->networks['Amazon'] = "amazon";
			$this->networks['BBC ID'] = "bbcid";
			$this->networks['Bebo'] = "bebo";
			$this->networks['Concrete5'] = "concrete5";
			$this->networks['Creative Commons'] = "creativecommons";
			$this->networks['Dailymile'] = "dailymile";
			$this->networks['Delicous'] = "delicious";
			$this->networks['Digg'] = "digg";
			$this->networks['Dopplr'] = "dopplr";
			$this->networks['Dribble'] = "dribble";
			$this->networks['eBay'] = "ebay";
			$this->networks['E-mail'] = "email";
			$this->networks['Facebook'] = "facebook";
			$this->networks['Feed'] = "feed";
			$this->networks['FFFFound'] = "ffffound";
			$this->networks['Fire Eagle'] = "fireeagle";
			$this->networks['Fitocracy'] = "fitocracy";
			$this->networks['Flickr'] = "flickr";
			$this->networks['FormSpring'] = "formspring";
			$this->networks['Forrst'] = "forrst";
			$this->networks['Foursquare'] = "foursquare";
			$this->networks['GeoTag'] = "geotag";
			$this->networks['Get Satisfaction'] = "getsatisfaction";
			$this->networks['Github'] = "github";
			$this->networks['GoodReads'] = "goodreads";
			$this->networks['Google'] = "google";
			$this->networks['Google+'] = "google+";
			$this->networks['Google Talk'] = "google-talk";
			$this->networks['Gowalla'] = "gowalla";
			$this->networks['HuffDuffer'] = "huffduffer";
			$this->networks['Hyves'] = "hyves";
			$this->networks['Identi.ca'] = "identica";
			$this->networks['iLike'] = "ilike";
			$this->networks['IMDb'] = "imdb";
			$this->networks['iTunes'] = "itunes";
			$this->networks['Lanyrd'] = "lanyrd";
			$this->networks['Last.fm'] = "lastfm";
			$this->networks['LinkedIn'] = "linkedin";
			$this->networks['Meetup'] = "meetup";
			$this->networks['Messenger'] = "messenger";
			$this->networks['Mixx'] = "mixx";
			$this->networks['MySpace'] = "myspace";
			$this->networks['NetVibes'] = "netvibes";
			$this->networks['NewsVine'] = "newsvine";
			$this->networks['Nike+'] = "nikeplus";
			$this->networks['OpenID'] = "openid";
			$this->networks['Orkut'] = "orkut";
			$this->networks['PayPal'] = "paypal";
			$this->networks['Picasa'] = "picasa";
			$this->networks['PinBoard'] = "pinboard";
			$this->networks['Pinterest'] = "pinterest";
			$this->networks['Plancast'] = "plancast";
			$this->networks['Posterous'] = "posterous";
			$this->networks['Rdio'] = "rdio";
			$this->networks['Readernaut'] = "readernaut";
			$this->networks['Reddit'] = "reddit";
			$this->networks['Runkeeper'] = "runkeeper";
			$this->networks['Share'] = "share";
			$this->networks['Skype'] = "skype";
			$this->networks['SlideShare'] = "slideshare";
			$this->networks['Speaker Deck'] = "speakerdeck";
			$this->networks['Spotify'] = "spotify";
			$this->networks['StumbleUpon'] = "stumbleupon";
			$this->networks['Tumblr'] = "tumblr";
			$this->networks['Twitter'] = "twitter";
			$this->networks['Upcoming'] = "upcoming";
			$this->networks['vCard'] = "vcard";
			$this->networks['Viddler'] = "viddler";
			$this->networks['Vimeo'] = "vimeo";
			$this->networks['Website'] = "website";
			$this->networks['Wikipedia'] = "wikipedia";
			$this->networks['xBox Live'] = "xbox";
			$this->networks['Xing'] = "xing";
			$this->networks['Yahoo!'] = "yahoo";
			$this->networks['Yahoo! Messenger'] = "yahoo-messenger";
			$this->networks['Yelp'] = "yelp";
			$this->networks['YouTube'] = "youtube";
			$this->networks['Zootool'] = "zootool";
		}
		return $this->networks; 	
	}
}

?>